diff -Nru dist-3.5-36.0001/mcon/man/Jmakefile dist-3.5-236/mcon/man/Jmakefile
--- dist-3.5-36.0001/mcon/man/Jmakefile	2006-08-26 00:31:50.000000000 +0200
+++ dist-3.5-236/mcon/man/Jmakefile	2017-10-24 22:43:40.000000000 +0200
@@ -2,7 +2,7 @@
  * Jmakefile for metaconfig manual pages
  */
 
-;# $Id: Jmakefile 9 2006-08-25 22:31:50Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/man/mconfig.SH dist-3.5-236/mcon/man/mconfig.SH
--- dist-3.5-36.0001/mcon/man/mconfig.SH	2018-05-20 22:49:04.000000000 +0200
+++ dist-3.5-236/mcon/man/mconfig.SH	2018-05-20 22:49:04.000000000 +0200
@@ -20,10 +20,10 @@
 .TH METACONFIG $manext "Version $VERSION PL$PATCHLEVEL"
 .\" @(#) Manual page for metaconfig
 .\"
-.\" $Id: mconfig.SH 25 2008-05-28 11:19:25Z rmanfredi $
+.\" $Id$
 .\"
 .\"  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-.\"
+.\"  
 .\"  You may redistribute only under the terms of the Artistic Licence,
 .\"  as specified in the README file that comes with the distribution.
 .\"  You may reuse parts of this distribution only within the terms of
@@ -349,7 +349,7 @@
 .IP \(bu
 Rerun \fImetaconfig\fR.
 .IP \(bu
-Send your unit to ram@acri.fr (Raphael Manfredi) for inclusion
+Send your unit to Raphael.Manfredi@pobox.com (Raphael Manfredi) for inclusion
 in the master copy, if you think it's of general interest.
 .PP
 In order to add a new program to be located:
@@ -528,6 +528,19 @@
 .TP
 .B \-V
 Print version number and exit.
+.TP
+\fB\-X\fI file\fR
+When examining the source files, ignore any symbols listed in the \fIfile\fR.
+This is useful in situations where a particular unit is known not to be needed
+for your package's portability targets, but your source files nevertheless
+contain occurrences of words that look to \fImetaconfig\fR like symbols defined
+in that unit. (For example, you might need the word "index" in a source file,
+but not need the unit that determines whether \fIstrcpy\fR or \fIindex\fR
+should be used.)
+The \fIfile\fR can contain blank lines, comment lines introduced with '#', and
+lines containing a single symbol.
+If this option is not supplied, any \fI$exclusions_file\fR variable in
+\fI.package\fR is honored instead.
 .\"
 .\" T u t o r i a l
 .\"
@@ -2077,7 +2090,7 @@
 .br
 Harlan Stenn <harlan@mumps.pfcs.com> for important unit extensions.
 .br
-Raphael Manfredi <ram@hptnos02.grenoble.hp.com>.
+Raphael Manfredi <Raphael.Manfredi@pobox.com>.
 .br
 Many other contributors for the
 \fImetaconfig\fR units. See the credit file for a list.
diff -Nru dist-3.5-36.0001/mcon/man/mlint.SH dist-3.5-236/mcon/man/mlint.SH
--- dist-3.5-36.0001/mcon/man/mlint.SH	2018-05-20 22:49:04.000000000 +0200
+++ dist-3.5-236/mcon/man/mlint.SH	2018-05-20 22:49:04.000000000 +0200
@@ -20,7 +20,7 @@
 .TH METALINT $manext "Version $VERSION PL$PATCHLEVEL"
 .\" @(#) Manual page for metalint
 .\"
-.\" $Id: mlint.SH 1 2006-08-24 12:32:52Z rmanfredi $
+.\" $Id$
 .\"
 .\"  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 .\"  
@@ -113,6 +113,19 @@
 .SH DIAGNOSTICS
 The following diagnostics may be emitted by \fImetalint\fR:
 .TP 5
+"(?MAKE) command line must start with a leading TAB character."
+Self explanatory.
+.TP
+"(?MAKE) fourth pick argument is missing."
+Self explanatory.
+.TP
+"(?MAKE) fourth pick argument should probably be the %< macro."
+When the fourth argument is not a relative path, it is expected to be the
+current unit name, which is best described using the "%<" string, a macro
+handled by
+.I metaconfig
+and which is substituted with the current unit name.
+.TP
 "(?MAKE) ignoring duplicate dependency listing line."
 More than one ?MAKE: line bearing dependencies was found in the unit. There
 may be only one such line, although multiple ?MAKE action lines may occur.
@@ -136,6 +149,19 @@
 will consider this as being a full dependency, but that may not be what you
 initially wanted...
 .TP
+"(?MAKE) pick needs a command argument."
+There is no command name after the special "pick" directive, which is invalid.
+.TP
+"(?MAKE) third pick argument must be \$@.
+The third argument to the special "pick" directive must be \$@, litterally.
+.TP
+"(?MAKE) unknown pick command 'xxx'.
+The command argument listed for the special "pick" directive is unknown.
+.TP
+"(?MAKE) weird fourth argument 'xxx' to pick.
+The fourth argument for pick, the target file, should be a unit name, a file
+path introduced by "./" or the special "%<" token.
+.TP
 "(?Y) unknown layout directive 'xxx'."
 Layout directives may only be one of \fItop\fR, \fIdefault\fR or \fIbottom\fR,
 but case does not matter. An unknown directive is just ignored and
@@ -150,14 +176,14 @@
 not listed as a dependency.
 .TP
 "(?S) syntax error in ?S: construct."
-Self explainatory.
+Self explanatory.
 .TP
 "(?C) duplicate description for symbol 'XXX'."
 C symbol is described more than once, and that will produce two entries for
 it in the Glossary.
 .TP
 "(?C) syntax error in ?C: construct."
-Self explainatory.
+Self explanatory.
 .TP
 "(?H) symbol 'XXX' was already defined."
 Apparently, two ?H: lines are defining the same C symbol.
@@ -190,7 +216,7 @@
 shell or C symbol, defined in the unit.
 .TP
 "(?M) syntax error in ?M: construct."
-Self explainatory.
+Self explanatory.
 .TP
 "(?M) symbol 'xxx' already listed on a ?M: line in 'yyy'."
 A magic definition for symbol xxx is attempted, but another one was
@@ -240,7 +266,7 @@
 Exceptions allowed if the ?F: line is preceded by a proper ?LINT: hint.
 .TP
 "(?T) temporary symbol '\$xxx' multiply declared."
-Self explainatory.
+Self explanatory.
 .TP
 "directive should come after ?MAKE declarations."
 The directive listed between () at the beginning of this message should
@@ -375,22 +401,22 @@
 a temporary.
 .TP
 "Shell symbol 'xxx' is both defined and obsoleted:"
-Self explainatory.
+Self explanatory.
 .TP
 "Shell symbol 'xxx' is both defined and used as temporary:"
-Self explainatory.
+Self explanatory.
 .TP
 "Shell symbol 'xxx' obsoleted also used as temporary:"
-Self explainatory.
+Self explanatory.
 .TP
 "definition of '\$xxx' not closed by '?S:.'."
-Self explainatory.
+Self explanatory.
 .TP
 "definition of 'XXX' not closed by '?C:.'."
-Self explainatory.
+Self explanatory.
 .TP
 "magic definition of 'xxx' not closed by '?M:.'."
-Self explainatory.
+Self explanatory.
 .TP
 "variable '\$xxx' is defined externally."
 A variable defined externally (i.e. in another unit) is used, without proper
@@ -536,7 +562,7 @@
 Harlan Stenn <harlan@mumps.pfcs.com> wrote the first version, based on
 Larry Wall's \fImetaconfig\fR from dist 2.0.
 .br
-Raphael Manfredi <ram@hptnos02.grenoble.hp.com> rewrote it from scratch for
+Raphael Manfredi <Raphael.Manfredi@pobox.com> rewrote it from scratch for
 3.0 with a few enhancements.
 .SH FILES
 .TP 10
diff -Nru dist-3.5-36.0001/mcon/man/mxref.SH dist-3.5-236/mcon/man/mxref.SH
--- dist-3.5-36.0001/mcon/man/mxref.SH	2018-05-20 22:49:04.000000000 +0200
+++ dist-3.5-236/mcon/man/mxref.SH	2018-05-20 22:49:04.000000000 +0200
@@ -20,7 +20,7 @@
 .TH METAXREF $manext "Version $VERSION PL$PATCHLEVEL"
 .\" @(#) Manual page for metaxref
 .\"
-.\" $Id: mxref.SH 1 2006-08-24 12:32:52Z rmanfredi $
+.\" $Id$
 .\"
 .\"  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 .\"  
@@ -99,6 +99,19 @@
 .TP
 .B \-V
 Print version number and exit.
+.TP
+\fB\-X\fI file\fR
+When examining the source files, ignore any symbols listed in the \fIfile\fR.
+This is useful in situations where a particular unit is known not to be needed
+for your package's portability targets, but your source files nevertheless
+contain occurrences of words that look to \fImetaconfig\fR like symbols defined
+in that unit. (For example, you might need the word "index" in a source file,
+but not need the unit that determines whether \fIstrcpy\fR or \fIindex\fR
+should be used.)
+The \fIfile\fR can contain blank lines, comment lines introduced with '#', and
+lines containing a single symbol.
+If this option is not supplied, any \fI$exclusions_file\fR variable in
+\fI.package\fR is honored instead.
 .SH AUTHOR
 Harlan Stenn <harlan@mumps.pfcs.com>
 .SH FILES
diff -Nru dist-3.5-36.0001/mcon/mconfig.SH dist-3.5-236/mcon/mconfig.SH
--- dist-3.5-36.0001/mcon/mconfig.SH	2012-01-28 14:01:37.000000000 +0100
+++ dist-3.5-236/mcon/mconfig.SH	2017-10-24 22:43:40.000000000 +0200
@@ -21,7 +21,7 @@
 	eval 'exec perl -S \$0 \${1+"\$@"}'
 		if \$running_under_some_shell;
 
-# $Id: mconfig.SH 114 2012-01-28 13:01:37Z rmanfredi $
+# $Id$
 #
 #  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 #  
@@ -68,8 +68,10 @@
 &profile;						# Read ~/.dist_profile
 
 use Getopt::Std;
-&usage unless getopts("dhkmostvwGMVL:");
+&usage unless getopts("dhkmostvwGMVL:X:");
 
+my %excluded_symbol;
+read_exclusions($opt_X);
 $MC = $opt_L if $opt_L;			# May override public library path
 $MC = &tilda_expand($MC);		# ~name expansion
 chop($WD = `pwd`);				# Working directory
@@ -150,7 +152,7 @@
 # Print out metaconfig's usage and exits
 sub usage {
 	print STDERR <<'EOH';
-Usage: metaconfig [-dhkmostvwGMV] [-L dir]
+Usage: metaconfig [-dhkmostvwGMV] [-L dir] [-X file]
   -d : debug mode.
   -h : print this help message and exits.
   -k : keep temporary directory.
@@ -164,6 +166,7 @@
   -L : specify main units repository.
   -M : activate production of confmagic.h.
   -V : print version number and exits.
+  -X : read symbol exclusions from file (overriding .package)
 EOH
 	exit 1;
 }
diff -Nru dist-3.5-36.0001/mcon/mlint.SH dist-3.5-236/mcon/mlint.SH
--- dist-3.5-36.0001/mcon/mlint.SH	2012-01-28 14:01:37.000000000 +0100
+++ dist-3.5-236/mcon/mlint.SH	2017-10-24 22:43:40.000000000 +0200
@@ -21,7 +21,7 @@
 	eval 'exec perl -S \$0 \${1+"\$@"}'
 		if \$running_under_some_shell;
 
-# $Id: mlint.SH 114 2012-01-28 13:01:37Z rmanfredi $
+# $Id$
 #
 #  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 #  
diff -Nru dist-3.5-36.0001/mcon/mxref.SH dist-3.5-236/mcon/mxref.SH
--- dist-3.5-36.0001/mcon/mxref.SH	2012-01-28 14:01:37.000000000 +0100
+++ dist-3.5-236/mcon/mxref.SH	2017-10-24 22:43:40.000000000 +0200
@@ -21,7 +21,7 @@
 	eval 'exec perl -S \$0 \${1+"\$@"}'
 		if \$running_under_some_shell;
 
-# $Id: mxref.SH 114 2012-01-28 13:01:37Z rmanfredi $
+# $Id$
 #
 #  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 #  
@@ -60,10 +60,12 @@
 &profile;						# Read ~/.dist_profile
 
 use Getopt::Std;
-&usage unless getopts("df:hkmsVL:");
+&usage unless getopts("df:hkmsVL:X:");
 
 chop($date = `date`);
 chop($WD = `pwd`);				# Working directory
+my %excluded_symbol;
+read_exclusions($opt_X);
 $MC = $opt_L if $opt_L;			# May override  library path
 $MC = &tilda_expand($MC);		# ~name expansion
 chdir $MC || die "Can't chdir to $MC: $!\n";
@@ -119,7 +121,7 @@
 # Print out metaxref's usage and exits
 sub usage {
 	print STDERR <<EOM;
-Usage: metaxref [-dhkmsV] [-f manifest] [-L dir]
+Usage: metaxref [-dhkmsV] [-f manifest] [-L dir] [-X file]
   -d : debug mode.
   -f : use that file as manifest instead of MANIFEST.new.
   -h : print this help message and exits.
@@ -128,6 +130,7 @@
   -s : silent mode.
   -L : specify main units repository.
   -V : print version number and exits.
+  -X : read symbol exclusions from file (overriding .package)
 EOM
 	exit 1;
 }
diff -Nru dist-3.5-36.0001/mcon/pl/common.pl dist-3.5-236/mcon/pl/common.pl
--- dist-3.5-36.0001/mcon/pl/common.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/common.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: common.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/configure.pl dist-3.5-236/mcon/pl/configure.pl
--- dist-3.5-36.0001/mcon/pl/configure.pl	2008-05-28 13:19:25.000000000 +0200
+++ dist-3.5-236/mcon/pl/configure.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: configure.pl 25 2008-05-28 11:19:25Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -77,7 +77,8 @@
 			warn "\t    $msg\n";
 		}
 	}
-	die "Can't open $file.\n" unless open(UNIT, $file);
+	die "Can't open $file.($name for target $target): $!\n"
+		unless open(UNIT, $file);
 	print "\t$cmd $file\n" if $opt_v;
 	&init_interp;						# Initializes the interpreter
 
@@ -215,9 +216,9 @@
 	elsif ($cmd eq 'prepend') {
 		if (-s $file) {
 			open(PREPEND, ">.prepend") ||
-				die "Can't create .MT/.prepend.\n";
+				die "Can't create .MT/.prepend: $!\n";
 			open(TARGET, $Unit{$target}) ||
-				die "Can't open $Unit{$target}.\n";
+				die "Can't open unit $Unit{$target}: $!\n";
 			while (<TARGET>) {
 				print PREPEND unless &skipped;
 			}
@@ -225,7 +226,7 @@
 			close PREPEND;
 			close TARGET;
 			rename('.prepend', $file) ||
-				die "Can't rename .prepend into $file.\n";
+				die "Can't rename .prepend into $file: $!\n";
 		}
 	}
 
diff -Nru dist-3.5-36.0001/mcon/pl/cosmetic.pl dist-3.5-236/mcon/pl/cosmetic.pl
--- dist-3.5-36.0001/mcon/pl/cosmetic.pl	2008-01-05 00:14:00.000000000 +0100
+++ dist-3.5-236/mcon/pl/cosmetic.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: cosmetic.pl 20 2008-01-04 23:14:00Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/depend.pl dist-3.5-236/mcon/pl/depend.pl
--- dist-3.5-36.0001/mcon/pl/depend.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/depend.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: depend.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -52,6 +52,9 @@
 		$cmaster{$_} = undef;					# Asks for look-up in C files
 		$cwanted{$_} = "$active" if $active;	# Shell symbols to activate
 	}
+
+	delete @cmaster{keys %excluded_symbol};
+	delete @cwanted{keys %excluded_symbol};
 }
 
 # Process the ?INIT: lines
diff -Nru dist-3.5-36.0001/mcon/pl/eval.pl dist-3.5-236/mcon/pl/eval.pl
--- dist-3.5-36.0001/mcon/pl/eval.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/eval.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: eval.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/extract.pl dist-3.5-236/mcon/pl/extract.pl
--- dist-3.5-36.0001/mcon/pl/extract.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/extract.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: extract.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/files.pl dist-3.5-236/mcon/pl/files.pl
--- dist-3.5-36.0001/mcon/pl/files.pl	2008-05-28 10:05:12.000000000 +0200
+++ dist-3.5-236/mcon/pl/files.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: files.pl 23 2008-05-28 08:05:12Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -29,6 +29,9 @@
 ;# extensions to their packages. For instance, perl5 adds .xs files holding
 ;# some C symbols.
 ;#
+;# The read_exclusions() routine honours the .package $exclusions_file
+;# variable if its argument is undefined.
+;#
 # Extract filenames from manifest
 sub extract_filenames {
 	&build_filext;			# Construct &is_cfile and &is_shfile
@@ -106,3 +109,26 @@
 	$_;
 }
 
+sub read_exclusions {
+	my ($filename) = @_;
+	if (!defined $filename) {
+		$filename = $exclusions_file; # default to name from .package
+		return if !defined $filename || $filename eq '';
+	}
+	print "Reading exclusions from $filename...\n" unless $opt_s;
+	open(EXCLUSIONS, "< $filename\0") || die "Can't read $filename: $!\n";
+	local $_;
+	while (<EXCLUSIONS>) {
+		if (/^\s*#|^\s*$/) {
+			# comment or blank line, ignore
+		}
+		elsif (/^\s*(\w+)\s*$/) {
+			$excluded_symbol{$1} = 1;
+		}
+		else {
+			die "$filename:$.: unrecognised line\n";
+		}
+	}
+	close(EXCLUSIONS) || die "Can't close $filename: $!\n";
+}
+
diff -Nru dist-3.5-36.0001/mcon/pl/gensym.pl dist-3.5-236/mcon/pl/gensym.pl
--- dist-3.5-36.0001/mcon/pl/gensym.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/gensym.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: gensym.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/init.pl dist-3.5-236/mcon/pl/init.pl
--- dist-3.5-36.0001/mcon/pl/init.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/init.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: init.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/lint.pl dist-3.5-236/mcon/pl/lint.pl
--- dist-3.5-36.0001/mcon/pl/lint.pl	2012-02-09 20:15:13.000000000 +0100
+++ dist-3.5-236/mcon/pl/lint.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: lint.pl 132 2012-02-09 19:15:13Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -110,7 +110,8 @@
 	@make = ();					# Records make dependency lines
 	$body = 'p_body';			# Procedure to handle body
 	$ending = 'p_end';			# Called at the end of each unit
-	@wiping = qw( 				# The keywords we recognize for "wiped" units
+	@wiping =				# The keywords we recognize for "wiped" units
+	qw(
 		PACKAGENAME
 		MAINTLOC
 		VERSION
@@ -125,6 +126,50 @@
 sub end_extraction {
 }
 
+# Process the command line of ?MAKE: lines
+sub p_make_command {
+	local ($_) = @_;
+	my $where = "\"$file\", line $. (?MAKE:)";
+	unless (s/^\t+//) {
+		warn "$where: command line must start with a leading TAB character.\n";
+		s/^\s+//;				# Remove spaces and continue
+	}
+	return unless s/^-?pick\b//;
+	# Validate the special "pick" make command, processed internally
+	# by metaconfig.
+	my %valid = map { $_ => 1 } qw(
+		add add.Config_sh add.Null
+		c_h_weed cm_h_weed close.Config_sh
+		prepend weed wipe
+
+	);
+	my $cmd;
+	$cmd = $1 if s/^\s+(\S+)//;
+	unless (defined $cmd) {
+		warn "$where: pick needs a command argument.\n";
+		return;
+	}
+	$wiped_unit++ if $cmd eq 'wipe';
+	warn "$where: unknown pick command '$cmd'.\n" unless $valid{$cmd};
+	s/^\s+//;
+	unless (s/^\$\@//) {
+		warn "$where: third pick argument must be \$\@\n";
+		return;
+	}
+	s/^\s+//;
+	my $target;
+	$target = $1 if s/^(\S+)//;
+	unless (defined $target) {
+		warn "$where: fourth pick argument is missing\n";
+		return;
+	}
+	return if $target =~ m|^\./|;
+	warn "$where: weird fourth argument '$target' to pick.\n"
+		unless $target =~ /^\w+$/;
+	warn "$where: fourth pick argument should probably be the %< macro.\n"
+		unless $target eq $unit;
+}
+
 # Process the ?MAKE: line
 sub p_make {
 	local($_) = @_;
@@ -132,7 +177,7 @@
 	local(@dep);					# Dependencies
 	local($where) = "\"$file\", line $. (?MAKE:)";
 	unless (/^[\w+ ]*:/) {
-		$wiped_unit++ if /^\t+-pick\s+wipe\b/;
+		&p_make_command;
 		return;						# We only want the main dependency rule
 	}
 	warn "$where: ignoring duplicate dependency listing line.\n"
@@ -753,7 +798,7 @@
 	# afterwards...
 
 	my $check_vars = 1;
-	$chek_vars = 0 if $heredoc_nosubst && !$began_here;
+	$check_vars = 0 if $heredoc_nosubst && !$began_here;
 
 	# Record any attempt made to set a shell variable
 	local($sym);
diff -Nru dist-3.5-36.0001/mcon/pl/locate.pl dist-3.5-236/mcon/pl/locate.pl
--- dist-3.5-36.0001/mcon/pl/locate.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/locate.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: locate.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -122,7 +122,7 @@
 	print "Locating in $MC/$dir...\n" if $main'opt_v;
 	@contents = readdir DIR;			# Slurp the whole thing
 	closedir DIR;						# And close dir, ready for recursion
-	foreach (@contents) {
+	foreach (sort @contents) {
 		next if $_ eq '.' || $_ eq '..';
 		if (/\.U$/) {					# A unit, definitely
 			($unit_name) = /^(.*)\.U$/;
diff -Nru dist-3.5-36.0001/mcon/pl/makefile.pl dist-3.5-236/mcon/pl/makefile.pl
--- dist-3.5-36.0001/mcon/pl/makefile.pl	2008-01-05 00:14:00.000000000 +0100
+++ dist-3.5-236/mcon/pl/makefile.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: makefile.pl 20 2008-01-04 23:14:00Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/obsolete.pl dist-3.5-236/mcon/pl/obsolete.pl
--- dist-3.5-36.0001/mcon/pl/obsolete.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/obsolete.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: obsolete.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/order.pl dist-3.5-236/mcon/pl/order.pl
--- dist-3.5-36.0001/mcon/pl/order.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/order.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: order.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -33,7 +33,7 @@
 			# Ignore conditional symbol request
 		} else {
 			chop;
-			system;
+			system $_;
 		}
 	}
 	chdir($WD) || die "Can't chdir to $WD: $!.\n";
diff -Nru dist-3.5-36.0001/mcon/pl/tsort.pl dist-3.5-236/mcon/pl/tsort.pl
--- dist-3.5-36.0001/mcon/pl/tsort.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/tsort.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: tsort.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/wanted.pl dist-3.5-236/mcon/pl/wanted.pl
--- dist-3.5-36.0001/mcon/pl/wanted.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/wanted.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: wanted.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
diff -Nru dist-3.5-36.0001/mcon/pl/xref.pl dist-3.5-236/mcon/pl/xref.pl
--- dist-3.5-36.0001/mcon/pl/xref.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/xref.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: xref.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -55,6 +55,9 @@
 		$cwanted{$_} = "$fake";					# Attached to this symbol
 		push(@Master, "?$unit:$fake=''");		# Fake initialization
 	}
+
+	delete @cmaster{keys %excluded_symbol};
+	delete @cwanted{keys %excluded_symbol};
 }
 
 # Ingnore the following:
diff -Nru dist-3.5-36.0001/mcon/pl/xwant.pl dist-3.5-236/mcon/pl/xwant.pl
--- dist-3.5-36.0001/mcon/pl/xwant.pl	2006-08-24 14:32:52.000000000 +0200
+++ dist-3.5-236/mcon/pl/xwant.pl	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-;# $Id: xwant.pl 1 2006-08-24 12:32:52Z rmanfredi $
+;# $Id$
 ;#
 ;#  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
 ;#  
@@ -49,7 +49,7 @@
 		print "    Scanning .[chyl] files for symbols...\n" unless $opt_s;
 		$search = ' ' x (40 * (@cmaster + @ocmaster));	# Pre-extend
 		$search = "while (<>) {study;\n";				# Init loop over ARGV
-		foreach $key (keys(cmaster)) {
+		foreach $key (keys(%cmaster)) {
 			$search .= "\$cmaster{'$key'} .= \"\$ARGV#\" if /\\b$key\\b/;\n";
 		}
 		foreach $key (grep(!/^\$/, keys %Obsolete)) {
@@ -63,7 +63,7 @@
 		eval $search;
 		eval '';
 		$/ = "\n";
-		while (($key,$value) = each(cmaster)) {
+		while (($key,$value) = each(%cmaster)) {
 			next if $value eq '';
 			foreach $file (sort(split(/#/, $value))) {
 				next if $file eq '';
@@ -94,7 +94,7 @@
 		$search = ' ' x (40 * (@shmaster + @oshmaster));	# Pre-extend
 		$search = "while (<>) {study;\n";
 		# All the keys already have a leading '$'
-		foreach $key (keys(shmaster)) {
+		foreach $key (keys(%shmaster)) {
 			$search .= "\$shmaster{'$key'} .= \"\$ARGV#\" if /\\$key\\b/;\n";
 		}
 		foreach $key (grep (/^\$/, keys %Obsolete)) {
@@ -108,7 +108,7 @@
 		eval $search;
 		eval '';
 		$/ = "\n";
-		while (($key,$value) = each(shmaster)) {
+		while (($key,$value) = each(%shmaster)) {
 			next if $value eq '';
 			foreach $file (sort(split(/#/, $value))) {
 				next if $file eq '';
diff -Nru dist-3.5-36.0001/mcon/U/AAAAA.U dist-3.5-236/mcon/U/AAAAA.U
--- dist-3.5-36.0001/mcon/U/AAAAA.U	2013-05-08 19:58:00.000000000 +0200
+++ dist-3.5-236/mcon/U/AAAAA.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,7 +1,7 @@
-?RCS: $Id: AAAAA.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
@@ -25,12 +25,12 @@
 ?RCS: Revision 3.0  1993/08/18  12:04:44  ram
 ?RCS: Baseline for dist 3.0 netwide release.
 ?RCS:
-?X: 
+?X:
 ?X: The purpose of this file is to supply the head of the Makefile created
 ?X: by metaconfig.  For this reason it must be first in alphabetical order.
 ?X: The leading '+' in front of the unit name is a hint for metalint, since
 ?X: the use of that special unit name as a "made" unit is legitimate here.
-?X: 
+?X:
 ?MAKE:+All: Finish
 ?X:
 ?X: Throughout the units, the following initials are used to identify comments:
diff -Nru dist-3.5-36.0001/mcon/U/abortsig.U dist-3.5-236/mcon/U/abortsig.U
--- dist-3.5-36.0001/mcon/U/abortsig.U	2018-05-20 22:49:04.000000000 +0200
+++ dist-3.5-236/mcon/U/abortsig.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,7 +1,7 @@
-?RCS: $Id: abortsig.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
diff -Nru dist-3.5-36.0001/mcon/U/active.U dist-3.5-236/mcon/U/active.U
--- dist-3.5-36.0001/mcon/U/active.U	2013-05-08 19:58:00.000000000 +0200
+++ dist-3.5-236/mcon/U/active.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,7 +1,7 @@
-?RCS: $Id: active.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
diff -Nru dist-3.5-36.0001/mcon/U/afs.U dist-3.5-236/mcon/U/afs.U
--- dist-3.5-36.0001/mcon/U/afs.U	2018-05-20 22:49:04.000000000 +0200
+++ dist-3.5-236/mcon/U/afs.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,13 +1,13 @@
-?RCS: $Id: afs.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
 ?RCS: that same Artistic License; a copy of which may be found at the root
 ?RCS: of the source tree for dist 4.0.
-?RCS: 
+?RCS:
 ?RCS: $Log: afs.U,v $
 ?RCS: Revision 3.0.1.2  1997/02/28  15:23:06  ram
 ?RCS: patch61: can now explicitly tell Configure whether AFS is running
@@ -27,7 +27,7 @@
 ?S:	This variable is by default set to '/afs'. In the unlikely case
 ?S:	this is not the correct root, it is possible to override this with
 ?S:	a hint value or command line option.  This will be used in subsequent
-?S:	tests for AFSness in the configure and test process. 
+?S:	tests for AFSness in the configure and test process.
 ?S:.
 : allow them to override the AFS root
 case "$afsroot" in
diff -Nru dist-3.5-36.0001/mcon/U/alignbytes.U dist-3.5-236/mcon/U/alignbytes.U
--- dist-3.5-36.0001/mcon/U/alignbytes.U	2013-05-08 19:58:00.000000000 +0200
+++ dist-3.5-236/mcon/U/alignbytes.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,7 +1,7 @@
-?RCS: $Id: alignbytes.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
diff -Nru dist-3.5-36.0001/mcon/U/Alpha_mieee.U dist-3.5-236/mcon/U/Alpha_mieee.U
--- dist-3.5-36.0001/mcon/U/Alpha_mieee.U	2013-05-08 19:58:00.000000000 +0200
+++ dist-3.5-236/mcon/U/Alpha_mieee.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,4 +1,4 @@
-?RCS: $Id: Alpha_mieee.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 2006, Christian Biere
 ?RCS:
diff -Nru dist-3.5-36.0001/mcon/U/archlib.U dist-3.5-236/mcon/U/archlib.U
--- dist-3.5-36.0001/mcon/U/archlib.U	2013-05-08 19:58:00.000000000 +0200
+++ dist-3.5-236/mcon/U/archlib.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,7 +1,7 @@
-?RCS: $Id: archlib.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
@@ -40,11 +40,11 @@
 ?S:	This variable holds the name of the directory in which the user wants
 ?S:	to put architecture-dependent public library files for $package.
 ?S:	It is most often a local directory such as /usr/local/lib.
-?S:	Programs using this variable must be prepared to deal 
+?S:	Programs using this variable must be prepared to deal
 ?S:	with filename expansion.
 ?S:.
 ?S:archlibexp:
-?S:	This variable is the same as the archlib variable, but is 
+?S:	This variable is the same as the archlib variable, but is
 ?S:	filename expanded at configuration time, for convenient use.
 ?S:.
 ?S:installarchlib:
diff -Nru dist-3.5-36.0001/mcon/U/archname.U dist-3.5-236/mcon/U/archname.U
--- dist-3.5-36.0001/mcon/U/archname.U	2013-05-08 19:58:00.000000000 +0200
+++ dist-3.5-236/mcon/U/archname.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,7 +1,7 @@
-?RCS: $Id: archname.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
diff -Nru dist-3.5-36.0001/mcon/U/baserev.U dist-3.5-236/mcon/U/baserev.U
--- dist-3.5-36.0001/mcon/U/baserev.U	2013-05-08 19:58:00.000000000 +0200
+++ dist-3.5-236/mcon/U/baserev.U	2017-10-24 22:43:40.000000000 +0200
@@ -1,7 +1,7 @@
-?RCS: $Id: baserev.U 167 2013-05-08 17:58:00Z rmanfredi $
+?RCS: $Id$
 ?RCS:
 ?RCS: Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
-?RCS: 
+?RCS:
 ?RCS: You may redistribute only under the terms of the Artistic License,
 ?RCS: as specified in the README file that comes with the distribution.
 ?RCS: You may reuse parts of this distribution only within the terms of
